unit shaders;

interface

const
  Color: AnsiString =
    '#include <metal_stdlib>'#10 +
    '#include <simd/simd.h>'#10 +
    'using namespace metal;'#10 +
    'typedef struct'#10 +
    '{'#10 +
     'vector_float4 position;'#10 +
     'vector_float4 color;'#10 +
    '} VertexIn;'#10 +
    'typedef struct'#10 +
    '{'#10 +
    'float4 position [[position]];'#10 +
    'float4 color;'#10 +
    '} VertexOut;'#10 +
    'struct Uniforms {'#10 +
    'float4x4 modelViewProjectionMatrix;'#10 +
    '};'#10 +
    'vertex VertexOut'#10 +
    'vertexShader(uint vertexID [[vertex_id]],'#10 +
             'constant VertexIn *vertices [[buffer(0)]],'#10 +
             'constant vector_uint2 *viewportSizePointer [[buffer(1)]],'#10 +
             'const device Uniforms* uniforms [[ buffer(2) ]])'#10 +
    '{'#10 +
      'VertexOut out;'#10 +
      //'out.clipSpacePosition = vector_float4(0.0, 0.0, 0.0, 1.0);'#10 +
      'float4 pixelSpacePosition = vertices[vertexID].position;'#10 +
      'vector_float2 viewportSize = vector_float2(*viewportSizePointer);'#10 +
      'float3 clipSpacePosition = float3 (pixelSpacePosition.xy/(viewportSize/2), pixelSpacePosition.z/viewportSize.y);'#10 +
      //'out.position = uniforms->modelViewProjectionMatrix * pixelSpacePosition;'#10 +
      'out.position = float4(clipSpacePosition,  1);'#10 +
      'out.color = vertices[vertexID].color;'#10 +
      'return out;'#10 +
    '}'#10 +

   'fragment float4 fragmentShader(VertexOut in [[stage_in]])'#10 +
   '{'#10 +
      'return in.color;'#10 +
   '}';

  Texture: AnsiString =
    '#include <metal_stdlib>'#10 +
    '#include <simd/simd.h>'#10 +
    'using namespace metal;'#10 +
    'typedef struct {'#10 +
    'float4 position;'#10 +
    'float4 color;'#10 +
    '} VertexIn;'#10 +
    'typedef struct {'#10 +
    'float4 position [[position]];'#10 +
    'float4 color;'#10 +
    '} VertexOut;'#10 +
    'struct Uniforms {'#10 +
    'float4x4 modelViewProjectionMatrix;'#10 +
    '};'#10 +
    'vertex VertexOut'#10 +
    'vertexShader(uint vertexID [[vertex_id]],'#10 +
             'constant VertexIn *vertices [[buffer(0)]],'#10 +
             'constant vector_uint2 *viewportSizePointer [[buffer(1)]],'#10 +
             'const device Uniforms* uniforms [[ buffer(2) ]])'#10 +
   '{'#10 +
    'VertexOut out;'#10 +
    'float4 pixelSpacePosition = vertices[vertexID].position;'#10 +
    'vector_float2 viewportSize = vector_float2(*viewportSizePointer);'#10 +
    'float3 clipSpacePosition = float3 (pixelSpacePosition.xy/(viewportSize/2), pixelSpacePosition.z/viewportSize.y);'#10 +
   // 'out.position = uniforms->modelViewProjectionMatrix * pixelSpacePosition;'#10 +
    'out.position = float4(clipSpacePosition,  1);'#10 +
    'out.color = vertices[vertexID].color;'#10 +
    'return out;'#10 +
    '}'#10 +

   'fragment float4 fragmentShader(VertexOut in [[stage_in]],'#10 +
      'texture2d<float> pngTexture [[ texture(0) ]])'#10 +
   '{'#10 +
      'constexpr sampler textureSampler (mag_filter::linear,min_filter::linear);'#10 +
      'return pngTexture.sample(textureSampler, in.color.xy);'#10 +
   '}';

implementation

end.


